#!/usr/bin/env python3
import sys
import wave

import rnnoise

def in_iter(fname, chunk_sz=4096):
    with wave.open(fname, 'rb') as infp:
        while True:
            data = infp.readframes(chunk_sz)
            if len(data) == 0:
                return
            yield data

rnn = rnnoise.RNNoise()

with wave.open(sys.argv[1], 'rb') as infp:
    params = infp.getparams()

with wave.open(sys.argv[2], 'wb') as outfp:
    outfp.setparams(params)

    for frames in rnn.iter_on(in_iter(sys.argv[1])):
        outfp.writeframes(frames)
